#! /usr/bin/python -u
# (Note: The -u disables buffering, as else we don't get julian's output.)
#
# Command and Control Application for Julian
#
# How to use it:
#  julius -quiet -input mic -C julian.jconf 2>/dev/null | ./command.py
#
# Copyright (C) 2008 Siegfried-Angel Gevatter Pujals <siggi.gevatter@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# Supported commands:
#
# This file is provided as an example, and should be modified to suit
# your needs.
#
# By default it supports some simple commands to control the Rhythmbox
# audio player. In order to use those, you have to create a grammar
# which recognizes sentences of the form "<name> <action>", where <name>
# is any word of your election (like for example "do" or "sound") and
# <action> can be one of the following words: play, pause, next, prev
# or show.

import sys
import os

def main_loop(file_object, callback):
	
	startstring = 'sentence1: <s> '
	endstring = ' </s>'
	
	while 1:
		line = file_object.readline()
		if not line:
			break
		if 'Missing phones:' in line:
			print 'Error: Missing phonemes for the used grammar file.'
			sys.exit(1)
		if line.startswith(startstring) and line.strip().endswith(endstring):
			callback(line.strip('\n')[len(startstring):-len(endstring)])

def parse(line):
	params = [param.lower() for param in line.split() if param]
	commands = {
		'play': 'rhythmbox-client --play',
		'pause': 'rhythmbox-client --pause',
		'next': 'rhythmbox-client --next',
		'prev': 'rhythmbox-client --previous',
		'show': 'rhythmbox-client --notify',
	}
	if params[1] in commands:
		os.popen(commands[params[1]])

if __name__ == '__main__':
	try:
		main_loop(sys.stdin, parse)
	except KeyboardInterrupt:
		sys.exit(1)
